# -.- coding: utf-8 -.-

# Affinity
#
# Copyright © 2010 Seif Lotfy <seif@lotfy.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import socket
import pickle
import time

from zeitgeist.datamodel import Event

client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
event = Event()
event.actor = "application://gedit.desktop"
event.timestamp = int(time.time()*1000)
msg = ("INSERT", "seilo", [event])
data = pickle.dumps(msg)
client_socket.connect(("", 5000))
client_socket.send(data)
client_socket.close()

